10 REM  1997/9
20 REM    DRAW ELEMENT PATTERN, DEFORMATION AND TRACTION 
30 REM          ----- I2SVCH FOR WINDOWS95 -----
40 REM                 BY TAKAYUKI HIRAI
50 DEFSTR Z
60 DIM X(8000,2),XX(8000,2),XY(8000,2),F(8000),NBB(300),NL(300,300)
70 DIM NH(100),MC(8000,2),MM(8000),MD(8000),DP(8000,2),P(8000,2,2),SP(8000,2)
80 OPEN "DD" FOR INPUT AS #1
90 CLS 
100 PRINT " "
110 PRINT "    DRAW ALL BLOCKS PICTURE,    BLOC =      0"
120 PRINT "    DRAW 1 BLOCK PICTURE,       BLOC = BLOCK NUMBER"
130 PRINT " ":INPUT "                    BLOC = ";BLOC
140 PRINT " ":PRINT " "
150 PRINT "      ELEMENT FIGURE                            ,  FIGU = 1"
160 PRINT "      BOUNDARY CONDITION PARALLEL TO BOUNDARY   ,  FIGU = 2"
170 PRINT "      BOUNCARY CONDITION VERTICAL TO BOUNDARY   ,  FIGU = 3"
180 PRINT " "
190 INPUT "                    FIGU = ";FIGU
200 IF FIGU=1 THEN GOTO 240
210 PRINT " "
220 input "        SCALE OF DISPLACEMENT =";SCD
230 INPUT "        SCALE OF TRACTION     =";SCT
240 PRINT " ":PRINT " "
250 INPUT #1,TITLE,NB,ND,NS,XS,YS,XYS
260 PRINT " MODEL =";TITLE
270 PRINT " "
280 PRINT " NUMBER OF BLOCK       =";NB
290 PRINT " NUMBER OF ELEMENT     =";ND
300 PRINT " NUMBER OF INNER POINT =";NS
310 PRINT " "
320 PRINT " NORMAL STRESS X GIVEN AT INFINITE DISTANCE    =";XS
330 PRINT " NORMAL STRESS Y GIVEN AT INFINITE DISTANCE    =";XS
340 PRINT " SHEARING STRESS XY GIVEN AT INFINITE DISTANCE =";XYS
350 FOR I=1 TO 10:INPUT #1,A1:NH(I)=A1:NEXT I
360 PRINT " "
370 PRINT " LAST NUMBER OF INNER POINT ON EACH BLOCK"
380 PRINT NH(1);NH(2);NH(3);NH(4);NH(5);NH(6);NH(7);NH(8);NH(9);NH(10)
390 FOR I=1 TO NB
400 PRINT " ":PRINT " "
410 INPUT " PUSH ENTER KEY";Z3
420 PRINT " "
430 PRINT "     BLOCK NUMBER =";I
440 INPUT #1,B1,B2,B3,B4,B5,B6
450 NBB(I)=B1
460 PRINT " EDGE  POISSON'S. RAT.  YOUNG'S MOD.  THICK.  PLANE ST./ST.  INI. STRAIN
470 PRINT NBB(I),B2,B3,B4,B5,B6
480 FOR J=1 TO 10:INPUT #1,A1
490 NL(I,J)=A1:NH(J)=A1:NEXT J
500 PRINT " LAST NUMBER OF ELEMENT ON EACH EDGE "
510 PRINT NH(1);NH(2);NH(3);NH(4);NH(5);NH(6);NH(7);NH(8);NH(9);NH(10)
520 NEXT I
530 PRINT " ":PRINT " "
540 INPUT " PUSH ENTER KEY";Z3
550 PRINT "  ELEMENT  B.C.  MD(I)   X   Y   BC-XL  BC-XR  BC-YL  BC-YR"
552 FOR I=1 TO ND
554 INPUT #1,A2,A3,A4,A5,A6,A7,A8,A9,A10
580 PRINT A2,A3,A4,A5,A6,A7,A8,A9,A10
585 IF A2><I THEN PRINT " ***** NODE NUMBER ERROR *****"
588 IF A2><I THEN INPUT " PUSH ENTER KEY";Z3
590 MM(I)=A3:MD(I)=A4:DP(I,1)=A5:DP(I,2)=A6
600 P(I,1,1)=A7:P(I,1,2)=A8:P(I,2,1)=A9:P(I,2,2)=A10
610 NEXT I
620 PRINT " ":PRINT " "
630 INPUT " PUSH ENTER KEY";Z3
635 IF NS=0 THEN GOTO 670
640 FOR I=1 TO NS
650 INPUT #1,N,SP(I,1),SP(I,2)
660 PRINT I,SP(I,1),SP(I,2):NEXT I
670 PRINT " ":PRINT " "
680 INPUT " PUSH ENTER KEY";Z3
690 REM
700 REM ------- ARRANGE AND SCALING --------
710 WP=3.14159
720 NEL=NL(NB,NBB(NB))
730 IT=0
740 FOR J8=1 TO NB
750 NE1=1:IF J8>1 THEN NE1=NL(J8-1,NBB(J8-1))+1
760 N1=NBB(J8)
770 FOR J9=1 TO N1
780 NE2=NL(J8,J9):IF J9>1 THEN NE1=NL(J8,J9-1)+1
790 FOR I=NE1 TO NE2
800 IT=IT+1:X(2*IT-1,1)=DP(I,1):X(2*IT,1)=DP(I,2)
810 IF I=NE1 THEN GOTO 830
820 X(2*(IT-1)-1,2)=DP(I,1):X(2*(IT-1),2)=DP(I,2):GOTO 840
830 X(2*NE2-1,2)=DP(I,1):X(2*NE2,2)=DP(I,2)
840 NEXT I:NEXT J9:NEXT J8
850 FOR I=1 TO ND:UU=X(2*I-1,2)-X(2*I-1,1)
860 VV=X(2*I,2)-X(2*I,1)
870 IF UU=0 THEN GOTO 910
880 FUV=ATN(VV/UU):IF UU>0 THEN GOTO 930
890 FUV=FUV+WP:IF VV<0 THEN FUV=FUV-WP*2!
900 GOTO 930
910 FUV=WP*.5:IF VV<0 THEN FUV=FUV-WP
920 IF VV=0 THEN FUV=0!
930 F(I)=FUV*180/WP
940 NEXT I
950 FOR I=1 TO IT
960 MC(I,1)=5:MC(I,2)=5
970 IF MM(I)=0 THEN GOTO 1050 
980 IF MM(I)=1 THEN MC(I,1)=9   
990 IF MM(I)=3 THEN MC(I,1)=9   
1000 IF MM(I)=2 THEN MC(I,2)=9   
1010 IF MM(I)=3 THEN MC(I,2)=9 
1020 IF MM(I)<4 THEN GOTO 1050
1030 IF I<MD(I) THEN GOTO 1050
1040 MC(I,1)=9:MC(I,2)=9
1050 SI9=SIN(F(I)*.0174533)*SCT:CO9=COS(F(I)*.0174533)*SCT
1060 IF MC(I,FIGU-1)=5 THEN GOTO 1080
1070 SI9=SIN(F(I)*.0174533)*SCD:CO9=COS(F(I)*.0174533)*SCD
1080 XX(I*2-1,1)=X(I*2-1,1)-P(I,1,1)*SI9        
1090 XX(I*2,1)=X(I*2,1)+P(I,1,1)*CO9        
1100 XX(I*2-1,2)=X(I*2-1,2)-P(I,1,2)*SI9        
1110 XX(I*2,2)=X(I*2,2)+P(I,1,2)*CO9        
1120 XY(I*2-1,1)=X(I*2-1,1)-P(I,2,1)*SI9        
1130 XY(I*2,1)=X(I*2,1)+P(I,2,1)*CO9        
1140 XY(I*2-1,2)=X(I*2-1,2)-P(I,2,2)*SI9        
1150 XY(I*2,2)=X(I*2,2)+P(I,2,2)*CO9
1160 NEXT I
1170 XA=999999!:XB=-999999!:YA=999999!:YB=-999999!
1180 I8=1:I9=IT
1190 IF BLOC>1 THEN I8=NL(BLOC-1,NBB(BLOC-1))+1
1200 IF BLOC>0 THEN I9=NL(BLOC,NBB(BLOC))
1210 FOR I=I8 TO I9
1220 IF X(I*2-1,1)<XA THEN XA=X(I*2-1,1)
1230 IF X(I*2-1,1)>XB THEN XB=X(I*2-1,1)
1240 IF X(I*2,1)<YA THEN YA=X(I*2,1)
1250 IF X(I*2,1)>YB THEN YB=X(I*2,1)
1260 IF XX(I*2-1,1)<XA THEN XA=XX(I*2-1,1)
1270 IF XX(I*2-1,1)>XB THEN XB=XX(I*2-1,1)
1280 IF XX(I*2-1,2)<XA THEN XA=XX(I*2-1,2)
1290 IF XX(I*2-1,2)>XB THEN XB=XX(I*2-1,2)
1300 IF XX(I*2,1)<YA THEN YA=XX(I*2,1)
1310 IF XX(I*2,1)>YB THEN YB=XX(I*2,1)
1320 IF XX(I*2,2)<YA THEN YA=XX(I*2,2)
1330 IF XX(I*2,2)>YB THEN YB=XX(I*2,2)
1340 IF XY(I*2-1,1)<XA THEN XA=XY(I*2-1,1)
1350 IF XY(I*2-1,1)>XB THEN XB=XY(I*2-1,1)
1360 IF XY(I*2-1,2)<XA THEN XA=XY(I*2-1,2)
1370 IF XY(I*2-1,2)>XB THEN XB=XY(I*2-1,2)
1380 IF XY(I*2,1)<YA THEN YA=XY(I*2,1)
1390 IF XY(I*2,1)>YB THEN YB=XY(I*2,1)
1400 IF XY(I*2,2)<YA THEN YA=XY(I*2,2)
1410 IF XY(I*2,2)>YB THEN YB=XY(I*2,2)
1420 NEXT I
1430 XM=XB-XA:YM=YB-YA
1440 SS=180/YM
1450 IF XM*4>YM*6 THEN SS=280/XM
1452 REM
1454 REM  ------ DRAW ELEMENT FIGURE -------
1460 #include"WINDOWS.BI"
1462 var FORM as object
1464 var BITMAP1 as object
1466 SETMAPMODE 1
1468 SETREDRAWMODE 1
1470 FORM.ATTACH GETHWND
1472 BITMAPOBJECT BITMAP1
1474 view (0,0)-(636,433)
1476 window (0,-3)-(620,210)
1478 color 0,15
1480 CLS
1482 if FIGU><1 then goto 1486
1484 print"    MODEL=";TITLE:GOTO 1500
1486 SSST=8/SS/SCT:SSSD=8/SS/SCD
1488 print"   RED FORCE SCALE=";SSST;" GREEN DISPLACEMENT SCALE=";SSSD;" MODEL=";TITLE
1500 N8=1:N9=NB:IF BLOC=0 THEN GOTO 1520
1510 N8=BLOC:N9=BLOC
1520 FOR J8=N8 TO N9
1530 NE1=1:IF J8>1 THEN NE1=NL(J8-1,NBB(J8-1))+1
1540 N1=NBB(J8)
1550 FOR J9=1 TO N1
1560 NE2=NL(J8,J9)
1570 IF J9>1 THEN NE1=NL(J8,J9-1)+1
1580 FOR I=NE1 TO NE2
1590 XL=CINT((X(2*I-1,1)-XA)*SS*2+15)
1600 XR=CINT((X(2*I-1,2)-XA)*SS*2+15)
1610 YL=CINT(190-(X(2*I,1)-YA)*SS)
1620 YR=CINT(190-(X(2*I,2)-YA)*SS)
1630 IF I>NE1 THEN F4=((F(I-1)+F(I))/2+90)*.0174533
1640 IF I=NE1 THEN F4=((F(NE2)+F(NE1))/2+90)*.0174533
1650 A1=COS(F4)*2
1660 A2=SIN(F4)*1
1670 B1=XL+A1:B2=YL-A2:C1=XL-A1:C2=YL+A2
1680 LINE (XL,YL)-(XR,YR),PSET,0:LINE (B1,B2)-(C1,C2),PSET,0
1690 NEXT I:NEXT J9:NEXT J8
1700 IF FIGU=1 THEN GOTO 2030
1730 REM
1740 REM ------ DRAW BOUNDARY CONDITION -------
1750 IF FIGU=2 THEN GOTO 1790
1760 IT2=IT*2
1770 FOR I=1 TO IT2:FOR J=1 TO 2
1780 XX(I,J)=XY(I,J):NEXT J:NEXT I
1790 N8=1:N9=NB:IF BLOC=0 THEN GOTO 1810
1800 N8=BLOC:N9=BLOC
1810 FOR J8=N8 TO N9
1820 NE1=1:IF J8>1 THEN NE1=NL(J8-1,NBB(J8-1))+1
1830 N1=NBB(J8)
1840 FOR J9=1 TO N1
1850 NE2=NL(J8,J9)
1860 IF J9>1 THEN NE1=NL(J8,J9-1)+1
1870 FOR I=NE1 TO NE2
1880 XL=CINT((X(2*I-1,1)-XA)*SS*2+15)
1890 XR=CINT((X(2*I-1,2)-XA)*SS*2+15)
1900 YL=CINT(190-(X(2*I,1)-YA)*SS)
1910 YR=CINT(190-(X(2*I,2)-YA)*SS)
1920 TXL=CINT((XX(2*I-1,1)-XA)*SS*2+15)
1930 TXR=CINT((XX(2*I-1,2)-XA)*SS*2+15)
1940 TYL=CINT(190-(XX(2*I,1)-YA)*SS)
1950 TYR=CINT(190-(XX(2*I,2)-YA)*SS)
1960 K=MC(I,FIGU-1)
1970 LINE(XL,YL)-(TXL,TYL),PSET,K:LINE (TXL,TYL)-(TXR,TYR),PSET,K
1980 LINE(TXR,TYR)-(XR,YR),PSET,K
1990 NEXT I:NEXT J9:NEXT J8
2000 LINE(5,6)-(5,-2),PSET,9:LINE(5,6)-(21,6),PSET,5
2010 BITMAP1.CREATEBITMAP 636,433
2012 BITMAP1.BITBLT 0,0,636,433,FORM,0,-3
2014 BITMAP1.SAVEFILE"AAA.BMP"
2020 BITMAP1.DELETEOBJECT
2022 cls
2024 BITMAP1.LOADFILE"AAA.BMP"
2026 FORM.BITBLT 0,-3,636,433,BITMAP1,0,0
2030 FOR I8=1 TO 9000
2040 wait 10
2050 Z4=inkey$
2060 if Z4="Q" then goto 2600
2070 IF Z4="q" THEN GOTO 2600
2080 if Z4="S" then goto 2600
2090 if Z4="s" then goto 2600
2100 next I8
2600 END
